Swift 2.3 / 3.0如何添加第三方库

分享到:  QQ好友和群QQ好友和群 QQ空间QQ空间 腾讯微博腾讯微博 腾讯朋友腾讯朋友 微信微信
查看查看353 回复回复1 收藏收藏 分享淘帖 转播转播 分享分享 微信
查看: 353|回复: 1
收起左侧

Swift 2.3 / 3.0如何添加第三方库

[复制链接]
3rdev 发表于 2016-8-18 19:46:14 | 显示全部楼层 |阅读模式
快来登录
获取优质的苹果资讯内容
收藏热门的iOS等技术干货
拷贝下载Swift Demo源代码
订阅梳理好了的知识点专辑

Swift 3的 beta 版现在已经出来了,Chris Lattner 之前在邮件里也大概提到说 Swift 3在八月就基本上全面完工(参见《宣告Swift3结束和Swift4开启》):

Swift 2.3 / 3.0如何添加第三方库 1

Swift 2.3 / 3.0如何添加第三方库 - 敏捷大拇指 - Swift 2.3 / 3.0如何添加第三方库 1


大家在写小 demo 或者是项目迁移到 Swift 3.0 的时候遇到最大的一个问题应该是第三方库的添加。

Swift 社区一直都是热情爆满,诸如 Alamofire、 Decodable等第三方库都有 Swift 3.0 的分支,但如果在导入的时没有处理一下,就总是会出各种奇奇怪怪的问题。我在这里分享一下我自己的解决方案。

其实主要要处理的问题就只有两个:

  • 指定第三方库的某个特定分支
  • 指定工程文件内 Swift 编译的版本





1、Cocoapods

这里以 Alamofire 为例,主要是需要在 podfile 里面多加点东西。



1.1、指定分支

首先是指定分支, cocoapods本身只支持 name 跟 version 两个参数, 但我们可以通过指定 git 仓库, 然后再指定 branch, 具体格式如下:

[Bash shell] 纯文本查看 复制代码
pod 'Alamofire', :git => 'https://github.com/Alamofire/Alamofire.git', :branch => 'swift3'




1.2、指定编译版本

还有就是指定 Swift 的版本, 只要在项目的最后加上下面这几句就可以了, 这里的几句话对项目里的 target 做了个遍历, 修改了全部 target 的 Swift 编译版本

[Bash shell] 纯文本查看 复制代码
post_install do |installer| 
	installer.pods_project.targets.each do |target|
		target.build_configurations.each do |config|
			config.build_settings['SWIFT_VERSION'] = '3.0'
		end
	end
end


但是这么写有一个缺点, Objective-C 跟 Swift 的混编项目, 如果想要引入 OC 的库的话, 就不能这么做了, 但是一个一个去设置编译版本又太麻烦, 我觉得最简单的还是直接进去项目里, 把SWIFT_VERSION这一项删掉就可以了

Swift 2.3 / 3.0如何添加第三方库 2

Swift 2.3 / 3.0如何添加第三方库 - 敏捷大拇指 - Swift 2.3 / 3.0如何添加第三方库 2


完整 podfile 如下:

[Bash shell] 纯文本查看 复制代码
project 'sample.xcodeproj'
platform :ios, '9.0'
target 'sample' do
	use_frameworks!
	pod 'Alamofire', :git => 'https://github.com/Alamofire/Alamofire.git', :branch => 'swift3'
end
post_install do |installer| 
	installer.pods_project.targets.each do |target|
		target.build_configurations.each do |config|
			config.build_settings['SWIFT_VERSION'] = '3.0'
		end
	end
end





2、Carthage

Carthage 的具体用法我就不解释了, 其实我个人而言还是更喜欢 Carthage, 自己操作过一遍基本上都能理解第三方库导入的过程了



2.1、指定分支

Carthage由于本身就是一个去中心化的包管理器, 所以在 cartfile 里面选择分支就可以了

[Bash shell] 纯文本查看 复制代码
github "Alamofire/Alamofire" "swift3"




2.2、指定编译版本

Carthage编译就很简单了, Swift 3的话直接 carthage update 就行了, xcodebuild 指向了Xcode 8的前提下, 默认 Swift 3, 但是 Swift 2.3的话就需要指定一下版本, 如下:

[Bash shell] 纯文本查看 复制代码
TOOLCHAINS=com.apple.dt.toolchain.Swift_2_3 carthage update --platform ios


然后编译的时候有一点需要注意的是, Carthage 默认会调用 xcode build 去变异, 如果我们电脑同时有两个版本的 Xcode 的时候, 需要确认一下 Xcode build 的版本

Swift 2.3 / 3.0如何添加第三方库 3

Swift 2.3 / 3.0如何添加第三方库 - 敏捷大拇指 - Swift 2.3 / 3.0如何添加第三方库 3


如果不是 Xcode 8的话, 就运行一下这条命令去修改就可以了

[Bash shell] 纯文本查看 复制代码
sudo ./xcode-select -switch /Applications/Xcode-beta.app/





3、最后

Swift 的各方各面都让人觉得欲罢不能, 比起有点年纪的 Objective-C, 每天的接触都能感受到 Swift 各种神奇的写法

Swift 像是个什么都想要的任性的女朋友, 跟她一起会很累, 累的是你必须为了她的进步而更加努力去学习更多东西, 接触更多新的东西

“Swift 从入门到重新入门”看起来好像很悲催, 但如果改成”女朋友从认识到重新认识”, 其实也挺带感的…




作者:四娘

都看到这里了,就把这篇资料推荐给您的好朋友吧,让他们也感受一下。

回帖是一种美德,也是对楼主发帖的尊重和支持。

*声明:敏捷大拇指是全球最大的Swift开发者社区、苹果粉丝家园、智能移动门户,所载内容仅限于传递更多最新信息,并不意味赞同其观点或证实其描述;内容仅供参考,并非绝对正确的建议。本站不对上述信息的真实性、合法性、完整性做出保证;转载请注明来源并加上本站链接,敏捷大拇指将保留所有法律权益。如有疑问或建议,邮件至marketing@swifthumb.com

*联系:微信公众平台:“swifthumb” / 腾讯微博:@swifthumb / 新浪微博:@swifthumb / 官方QQ一群:343549891(满) / 官方QQ二群:245285613 ,需要报上用户名才会被同意进群,请先注册敏捷大拇指

嗯,不错!期待更多好内容,支持一把:
支持敏捷大拇指,用支付宝支付10.24元 支持敏捷大拇指,用微信支付10.24元

评分

参与人数 1金钱 +10 贡献 +10 专家分 +10 收起 理由
Anewczs + 10 + 10 + 10 32个赞!专家给力!

查看全部评分

本帖被以下淘专辑推荐:

数学家 发表于 2016-8-19 11:37:39 | 显示全部楼层
Swift版本会不会有后遗症?现在隐约有痛点了
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

做任务,领红包。
我要发帖

分享扩散

都看到这里了,就把这资料推荐给您的好朋友吧,让他们也感受一下。
您的每一位朋友访问此永久链接后,您都将获得相应的金钱积分奖励
热门推荐

合作伙伴

Swift小苹果

  • 北京治世天下科技有限公司
  • ©2014-2016 敏捷大拇指
  • 京ICP备14029482号
  • Powered by Discuz! X3.1 Licensed
  • swifthumb Wechat Code
  •   
快速回复 返回顶部 返回列表